

// I2C begin transmission
func beginTransmission(var device_address)
    I2C1_Start();
    I2C1_Write(device_address << 1|0);
endfunc
// I2C request
func requestFrom(var device_address)
    I2C1_Stop();
    I2C1_Start();
    I2C1_Write(device_address << 1|1);
endfunc
// I2C end Transmission
func endTransmission()
    I2C1_Stop();
endfunc

// decimal to BCD conversion
func decToBCD(var val)
    return( (val/10*16) + (val%10));
endfunc
// BCD to decimal conversion
func BCDtodec(var val)
    return( (val/16*10) + (val%16));
endfunc
// get seconds
func getSecond()
    var *sec;
    beginTransmission(CLOCK_ADDRESS);
    I2C1_Write(0x00);
    endTransmission();
    beginTransmission(CLOCK_ADDRESS);
    requestFrom(CLOCK_ADDRESS);
    sec := BCDtodec(I2C1_Read());
    I2C1_Nack();
    return sec;
endfunc

func getMinute()
    var min;
    beginTransmission(CLOCK_ADDRESS);
    I2C1_Write(0x01);
    endTransmission();
    beginTransmission(CLOCK_ADDRESS);
    requestFrom(CLOCK_ADDRESS);
    min := BCDtodec(I2C1_Read());
    I2C1_Nack();
    return min;
endfunc

func getHour()
    var hr;
    beginTransmission(CLOCK_ADDRESS);
    I2C1_Write(0x02);
    endTransmission();
    beginTransmission(CLOCK_ADDRESS);
    requestFrom(CLOCK_ADDRESS);
    hr := BCDtodec(I2C1_Read());
    I2C1_Nack();
    return hr;
endfunc

func getDayoftheWeek()
    var weekday;
    beginTransmission(CLOCK_ADDRESS);
    I2C1_Write(0x03);
    endTransmission();
    beginTransmission(CLOCK_ADDRESS);
    requestFrom(CLOCK_ADDRESS);
    weekday := BCDtodec(I2C1_Read());
    I2C1_Nack();
    return weekday;
endfunc

func getDateOfTheMonth()
    var date;
    beginTransmission(CLOCK_ADDRESS);
    I2C1_Write(0x04);
    endTransmission();
    beginTransmission(CLOCK_ADDRESS);
    requestFrom(CLOCK_ADDRESS);
    date := BCDtodec(I2C1_Read());
    I2C1_Nack();
    return date;
endfunc

func getMonth()
    var month;
    beginTransmission(CLOCK_ADDRESS);
    I2C1_Write(0x05);
    endTransmission();
    beginTransmission(CLOCK_ADDRESS);
    requestFrom(CLOCK_ADDRESS);
    month := BCDtodec(I2C1_Read());
    I2C1_Nack();
    return month;
endfunc

func getYear()
    var year;
    beginTransmission(CLOCK_ADDRESS);
    I2C1_Write(0x06);
    endTransmission();
    beginTransmission(CLOCK_ADDRESS);
    requestFrom(CLOCK_ADDRESS);
    year := BCDtodec(I2C1_Read());
    I2C1_Nack();
    return year;
endfunc

func dayOfTheWeek(var today)
    if(today == 1)
        print("SUNDAY");
    else if(today == 2)
        print("MONDAY");
    else if(today == 3)
        print("TUESDAY");
    else if(today == 4)
        print("WEDNESDAY");
    else if(today == 5)
        print("THURSDAY");
    else if(today == 6)
        print("FRIDAY");
    else if(today == 7)
        print("SATURDAY");
    endif
endfunc

func Month(var curMonth)
    if(curMonth == 1)
        print("January");
    else if(curMonth == 2)
        print("February");
    else if(curMonth == 3)
        print("March");
    else if(curMonth == 4)
        print("April");
    else if(curMonth == 5)
        print("May");
    else if(curMonth == 6)
        print("June");
    else if(curMonth == 7)
        print("July");
    else if(curMonth == 8)
        print("August");
    else if(curMonth == 9)
        print("September");
    else if(curMonth == 10)
        print("October");
    else if(curMonth == 11)
        print("November");
    else if(curMonth == 12)
        print("December");
    endif

endfunc

func setTime(var hour, var minute, var seconds)
    beginTransmission(CLOCK_ADDRESS);
    I2C1_Write(0x00);
    I2C1_Write(decToBCD(seconds));
    I2C1_Write(decToBCD(minute));
    I2C1_Write(decToBCD(hour));
    endTransmission();
endfunc

func setDay(var day)
    beginTransmission(CLOCK_ADDRESS);
    I2C1_Write(0x03);
    I2C1_Write(decToBCD(day));
    endTransmission();
endfunc

func setDate(var date, var month, var year)
    beginTransmission(CLOCK_ADDRESS);
    I2C1_Write(0x04);
    I2C1_Write(decToBCD(date));
    I2C1_Write(decToBCD(month));
    I2C1_Write(decToBCD(year));
    endTransmission();
endfunc
